#include <stdio.h>
#include <windows.h>
#include <iphlpapi.h>

int main(void)
{
  IP_ADAPTER_INFO AdapterInfo[16]; // per 16 MAC address
  IP_ADAPTER_INFO* pAdapterInfo; // per maneggiare il buffer
  DWORD dwBufLen;
  DWORD dwStatus;
  int i,j;
  char szMac[1000];

  dwBufLen = sizeof(AdapterInfo);		// dimensione del buffer
  // system call alla API Win32 appropriata
  dwStatus = GetAdaptersInfo(
               AdapterInfo,					// [out] buffer che contiene i MAC address
               &dwBufLen);					// [in] dimensione del buffer
  if (dwStatus!=NO_ERROR) return 1;

  j=0;
  pAdapterInfo = AdapterInfo;       // puntatore al buffer

  while(pAdapterInfo)	// se c' un elemento
  {
    j++;
    sprintf(szMac,"NIC %d, indirizzo MAC: ",j);
    for (i=0; i<6; i++)
    {
      sprintf(szMac+strlen(szMac)," %02x ",pAdapterInfo->Address[i]);
    }

    printf("\n%s\n%s \nNome: \\Device\\NPF_%s\n",pAdapterInfo->Description,szMac, pAdapterInfo->AdapterName);
    pAdapterInfo = pAdapterInfo->Next; // il prossimo...
  }

  return 0;
}


